'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = withBlockUi;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

var _reactDisplayName = require('react-display-name');

var _reactDisplayName2 = _interopRequireDefault(_reactDisplayName);

var _reactBlockUi = require('react-block-ui');

var _reactBlockUi2 = _interopRequireDefault(_reactBlockUi);

require('react-block-ui/style.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function withBlockUi() {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var loader = config.loader,
      _config$keepInView = config.keepInView,
      keepInView = _config$keepInView === undefined ? true : _config$keepInView,
      _config$sourceStateNa = config.sourceStateName,
      sourceStateName = _config$sourceStateNa === undefined ? 'source' : _config$sourceStateNa,
      otherProps = _objectWithoutProperties(config, ['loader', 'keepInView', 'sourceStateName']);

  return function (TargetComponent) {
    /* eslint-disable react/prefer-stateless-function */
    var WithBlockUi = function (_Component) {
      _inherits(WithBlockUi, _Component);

      function WithBlockUi() {
        _classCallCheck(this, WithBlockUi);

        return _possibleConstructorReturn(this, (WithBlockUi.__proto__ || Object.getPrototypeOf(WithBlockUi)).apply(this, arguments));
      }

      _createClass(WithBlockUi, [{
        key: 'render',
        value: function render() {
          var isPending = this.props[sourceStateName].isPending;

          return _react2.default.createElement(
            _reactBlockUi2.default,
            _extends({}, otherProps, {
              blocking: isPending,
              tag: 'div',
              loader: loader,
              keepInView: keepInView }),
            _react2.default.createElement(TargetComponent, this.props)
          );
        }
      }]);

      return WithBlockUi;
    }(_react.Component);
    /* eslint-enable react/prefer-stateless-function */


    (0, _hoistNonReactStatics2.default)(WithBlockUi, TargetComponent);
    WithBlockUi.displayName = 'WithBlockUi(' + (0, _reactDisplayName2.default)(TargetComponent) + ')';
    return WithBlockUi;
  };
}
module.exports = exports['default'];
//# sourceMappingURL=withBlockUi.js.map